;-----------------------------------------------------------------------------
;* frequenz.asm: zum Quarzfrequenz nachmessen    letzte Aenderung: 10.3.2009
;* Version: 0.0
;* Prozessor: Atmega8
;* Schaltschema: Port B0 mit Frequenzmessgeraet verbunden
;* Autor: Rolf Pfister
;* Copyright: Freeware
;* History:
;* 4.3.2009	Erstellung
;* 23.8.2012	Comments in english, (code didnt change)
;*
;-----------------------------------------------------------------------------
	.include "m8def.inc" 	; Definitionsdatei fuer den Prozessortyp
; Reset und Interruptvectoren	;VNr. Beschreibung
begin:	rjmp	main		; 1   Power On Reset
	reti			; 2   Int0-Interrupt
	reti			; 3   Int1-Interrupt
	reti			; 4   TC2 Compare Match
	reti			; 5   TC2 Overflow
	reti			; 6   TC1 Capture
	reti			; 7   TC1 Compare Match A
	reti			; 8   TC1 Compare Match B
	reti			; 9   TC1 Overflow
	reti			; 10  TC0 Overflow
	reti			; 11  SPI, STC = Serial Transfer Complete
	reti			; 12  UART Rx Complete
	reti			; 13  UART Data Register Empty
	reti			; 14  UART Tx Complete
	reti			; 15  ADC Conversion Complete
	reti			; 16  EEPROM ready
	reti			; 17  Analog Comperator
	reti			; 18  TWI (I2C) Serial Interface
	reti			; 19  Store Program Memory ready
;-----------------------------------------------------------------------------
; Start, Power On, Reset
main:	ldi r16, RAMEND&0xFF
        out SPL, r16  	     ; Init Stackpointer L
	ldi r16, RAMEND>>8
        out SPH, r16  	     ; Init Stackpointer H

;; Init-Code
	ldi r16, 0x01		;PB0 as output
        out DDRB, r16		;Data Direction Register B
	ldi r16, 0
	out PORTB, r16		;LED off
	ldi r17, 1

;-----------------------------------------------------------------------------
mainloop:
	out PORTB, r16		;Measure frequency of quartz:
	out PORTB, r17		;this loop needs 4 cycles, so
	rjmp mainloop		;measured frequency times 4 gives quartz frequency
