;-----------------------------------------------------------------------------
;* Musterprogramm: Warte-Unterprogramm      letzte Aenderung: 10.3.2009
;* Version: 0.0
;* Prozessor: Atmega8, 3.6864MHz
;* Schaltschema: dreiled.png, Port B0,B1,B2 mit LEDs verbunden
;* Autor: Rolf Pfister
;* Copyright: Freeware
;* History:
;* 4.3.2009	Erstellung
;*
;-----------------------------------------------------------------------------
	.include "m8def.inc" 	; Definitionsdatei fuer den Prozessortyp
; Reset und Interruptvectoren	;VNr. Beschreibung
begin:	rjmp	main		; 1   Power On Reset
	reti			; 2   Int0-Interrupt
	reti			; 3   Int1-Interrupt
	reti			; 4   TC2 Compare Match
	reti			; 5   TC2 Overflow
	reti			; 6   TC1 Capture
	reti			; 7   TC1 Compare Match A
	reti			; 8   TC1 Compare Match B
	reti			; 9   TC1 Overflow
	reti			; 10  TC0 Overflow
	reti			; 11  SPI, STC = Serial Transfer Complete
	reti			; 12  UART Rx Complete
	reti			; 13  UART Data Register Empty
	reti			; 14  UART Tx Complete
	reti			; 15  ADC Conversion Complete
	reti			; 16  EEPROM ready
	reti			; 17  Analog Comperator
	reti			; 18  TWI (I2C) Serial Interface
	reti			; 19  Store Program Memory ready
;-----------------------------------------------------------------------------
; Start, Power On, Reset
main:	ldi r16, RAMEND&0xFF
        out SPL, r16  	     ; Init Stackpointer L
	ldi r16, RAMEND>>8
        out SPH, r16  	     ; Init Stackpointer H

;; Init-Code
	ldi r16, 0xFF		;Alle Leitungen auf Ausgang
        out DDRB, r16		;Data Direction Register B setzen
	ldi r16, 0
	out PORTB, r16		;alle LEDs loeschen

;-----------------------------------------------------------------------------
mainloop:
	ldi r24, 50		;500 Millisec warten
	rcall zehnmilliwait
	inc r16
	out PORTB, r16
	rjmp mainloop

;-----------------------------------------------------------------------------
wait:	push r24		;Wartezeit bei 3.6864MHz: ca (r25+1)*209usec
	push r25
loop1:	ldi r24, 0xFF
loop2:	subi r24, 1
	brcc loop2
	subi r25, 1
	brcc loop1
	pop r25
	pop r24
	ret

zehnmilliwait:		;Wartezeit: ca r24*10 msec
	push r24
	push r25
loop3:	ldi r25, 48
	rcall wait
	subi r24, 1
	brne loop3
	pop r25
	pop r24
	ret
